using System;

class BliposClock
{
    private byte seconds;
    private short minutes;
     //Exercise 2
    private byte days;
    private ulong years;

    public BliposClock()
    {
        seconds = 0;
        minutes = 0;
         // Exercise 2
        days = 0;
        years = 0;
    }

    public void OneForward()
    {
        byte originalSeconds = seconds;
        short originalMinutes = minutes; //Ex. 2
        byte originalDays = days; //Ex. 2

        seconds++;
        if (originalSeconds > seconds)
             // Overflow of seconds variable
            minutes++;
         // Exercise 2
        if (originalMinutes > minutes)
             // Overflow of minutes variable
            days++;
        if (originalDays > days)
             // Overflow of days variable
            years++;
    }

    public void OneBackward()
    {
        byte originalSeconds = seconds;
        short originalMinutes = minutes; //Ex. 2
        byte originalDays = days; //Ex. 2

        seconds--;
        if (originalSeconds < seconds)
             // Underflow of seconds variable
            minutes--;
         // Exercise 2
        if (originalMinutes < minutes)
             // Underflow of minutes variable
            days--;
        if (originalDays < days)
             // Underflow of days variable
            years--; 
    }

    public void FastForward()
    {
        byte originalSeconds = seconds;
        short originalMinutes = minutes; //Ex. 2
        byte originalDays = days; //Ex. 2

        seconds = (byte)(seconds + 50);
        if (originalSeconds > seconds)
             // Overflow of seconds variable
            minutes++;
         // Exercise 2
        if (originalMinutes > minutes)
             // Overflow of minutes variable
            days++;
        if (originalDays > days)
             // Overflow of days variable
            years++;
    }

    public void FastBackward()
    {
        byte originalSeconds = seconds;
        short originalMinutes = minutes; //Ex. 2
        byte originalDays = days; //Ex. 2

        seconds = (byte)(seconds - 50);
        if (originalSeconds < seconds)
             // Underflow of seconds variable
            minutes--;
          // Exercise 2
        if (originalMinutes < minutes)
             // Underflow of minutes variable
            days--;
        if (originalDays < days)
             // Underflow of days variable
            years--; 
    }

     // Exercise 1
    public void HundredForward()
    {
        byte originalSeconds = seconds;
        short originalMinutes = minutes; //Ex. 2
        byte originalDays = days; //Ex. 2

        seconds = (byte)(seconds + 100);
        if (originalSeconds > seconds)
             // Overflow of seconds variable
            minutes++;
         // Exercise 2
        if (originalMinutes > minutes)
             // Overflow of minutes variable
            days++;
        if (originalDays > days)
             // Overflow of days variable
            years++;
    }

     // Exercise 1
    public void HundredBackward()
    {
        byte originalSeconds = seconds;
        short originalMinutes = minutes; //Ex. 2
        byte originalDays = days; //Ex. 2
    
        seconds = (byte)(seconds - 100);
        if (originalSeconds < seconds)
             // Underflow of seconds variable
            minutes--;
         // Exercise 2
        if (originalMinutes < minutes)
             // Underflow of minutes variable
            days--;
        if (originalDays < days)
             // Underflow of days variable
            years--; 
    }

    // Exercise 3
    public void AddOneDay()
    {
        byte originalDays = days;

        days++;
        if (originalDays > days)
             // Overflow of days variable
            years++;
    }

     // Exercise 3
    public void DeductOneDay()
    {
        byte originalDays = days;

        days--;
        if (originalDays < days)
             // Underflow of days variable
            years--;  
    }

     // Exercise 3
    public void AddOneYear()
    {
        years++;
    }

     // Exercise 3
    public void DeductOneYear()
    {
        years--;
    }
    

    public void SetSeconds(byte sec)
    {
        seconds = sec;
    }

    public void SetMinutes(short min)
    {
        minutes = min;
    }

     // Exercise 2
    public void SetDays(byte newDays)
    {
        days = newDays;
    }

     // Exercise 2
    public void SetYears(ulong newYears)
    {
        years = newYears;
    }

    public void ShowTime()
    {
        Console.WriteLine("Sec: " + seconds + " Min: " + minutes);
         // Exercise 2
        Console.WriteLine("Day/year: " + days + "/" + years);
         // Exercise 4 
        if (days == 100)
            Console.WriteLine("Happy Birthday Emperor!");
    }
}

class RunBliposClock
{
    public static void Main()
    {
        string command;

        Console.WriteLine("Welcome to the Blipos Clock. " +
            "256 seconds per minute " +
            "65536 minutes per day");
        BliposClock myClock = new BliposClock();
        Console.WriteLine("Please set the clock");
        Console.Write("Enter Seconds: ");
        myClock.SetSeconds(Convert.ToByte(Console.ReadLine()));
        Console.Write("Enter Minutes: ");
        myClock.SetMinutes(Convert.ToInt16(Console.ReadLine()));
        Console.Write("Enter Days: "); //Ex.2 
        myClock.SetDays(Convert.ToByte(Console.ReadLine())); //Ex.2
        Console.Write("Enter Years: "); //Ex.2
        myClock.SetYears(Convert.ToUInt64(Console.ReadLine())); //Ex.2
        Console.WriteLine("Enter command: F) Forward B) Backward " +
            "A) Add fifty ");
        Console.WriteLine("D) Deduct fifty H) Add hundred " + //Ex.1
            "M) Deduct hundred "); //Ex.1
        Console.WriteLine("Q) Add one Day  Y) Add one year " + //Ex.3
            "U) Deduct one day \n  W) Deduct one year  T) Terminate"); //Ex.3  
        do
        {
            command = Console.ReadLine().ToUpper();
            if (command == "F")
                myClock.OneForward();
            if (command == "B")
                myClock.OneBackward();
            if(command == "A")
                myClock.FastForward();
            if(command == "D")
                myClock.FastBackward();
             //Exercise 1
            if(command == "H")
                myClock.HundredForward();
            if(command == "M")
                myClock.HundredBackward();
             //Exercise 3
            if(command == "Q")
                myClock.AddOneDay();
            if(command == "Y")
                myClock.AddOneYear();
            if(command == "U")
                myClock.DeductOneDay();
            if(command == "W")
                myClock.DeductOneYear();
            myClock.ShowTime();
        } while (command != "T");
        Console.WriteLine("Thank you for using the Blipos Clock");
    }
}