using System;
using System.IO;

class Rainfall
{
    private static byte [] rainfall = new byte [12];
    private static FileStream outStream = null;
    private static FileStream inStream = null; 
    
    public static void Main()
    {
        string answer;
        int index;
        byte rainfallReading;
        
        Console.WriteLine("Choose between the following options: ");
        Console.WriteLine("I)nput a rainfall reading");
        Console.WriteLine("L)ist the rainfall readings");
        Console.WriteLine("S)ave the rainfall readings");
        Console.WriteLine("R)ead the rainfall readings from file");
        Console.WriteLine("T)erminate program");
    
        do
        {
            Console.Write("\nEnter choice: ");
            answer = Console.ReadLine().ToUpper();
            switch (answer)
            {
                case "I":
                    Console.Write("Enter month (1-12): ");
                    index = Convert.ToInt32(Console.ReadLine());
                    Console.Write("Enter rainfall reading: ");
                    rainfallReading = Convert.ToByte(Console.ReadLine());
                    rainfall[index - 1] = rainfallReading;
                break;
                case "L":
                    Console.WriteLine("Rainfall readings:");
                    foreach(int temp in rainfall)
                    {
                        Console.Write("{0} ", temp);
                    }
                    Console.WriteLine();
                break;
                case "T":
                    Console.WriteLine("Bye bye");
                break;
                case "S":
                    try
                    {
                        Console.WriteLine("Saving rainfall data to Rainfall.dat");
                        FileInfo byteOutFile = new FileInfo (@"C:\MyTestFiles\Rainfall.dat");
                        outStream = byteOutFile.OpenWrite();
                        for(int i = 0; i < 12; i++)
                        {
                            outStream.WriteByte(rainfall[i]);
                        }
                    }
                    
                    catch (IOException exObj)
                    {
                        Console.WriteLine(exObj);
                    }
                    
                    finally
                    {
                        outStream.Close();
                    }
                break;
                case "R":
                    try
                    {
                        Console.WriteLine("Reading data from Rainfall.dat");
                        FileInfo byteInFile = new FileInfo (@"C:\MyTestFiles\Rainfall.dat");
                        inStream = byteInFile.OpenRead();
                        for (int i = 0; i < inStream.Length; i++)
                        {
                            rainfall[i] = (byte)inStream.ReadByte();
                        }
                        inStream.Close();
                    }
                    
                    catch (IOException exObj)
                    {
                        Console.WriteLine(exObj);
                    }
                    
                    finally
                    {
                        inStream.Close();
                    }
                break;
                default:
                    Console.WriteLine("Invalid choice. Try again");
                break;
            }
        } while(answer != "T");
    }
}
